Index: extensions/GMaps/gmaps_pip.class.inc.php
===================================================================
--- extensions/GMaps/gmaps_pip.class.inc.php	(revision 7054)
+++ extensions/GMaps/gmaps_pip.class.inc.php	(revision 7125)
@@ -18,27 +18,50 @@
 class GMaps_PIP extends GMaps_root
 {
-  protected $coords = array();
-  protected $maps = array();
-  protected $content = '';
-  protected $pictureGeolocated;
+  protected $maps = array(); //list of maps
+  protected $category=array(
+    'id' => 0,
+    'bounds' => array(
+      'N' => -90,
+      'S' => 90,
+      'E' => -180,
+      'W' => 180
+    ),
+    'icon' => array(
+      'style' => true,
+      'file' => '',
+      'width' => -1,
+      'height' => -1
+    )
+  );
+  protected $picture=array(
+    'geolocated' => false,
+    'coords' => array('lat' => 0, 'lng' => 0),
+    'content' => array(
+      'I' => array(), // icon display mode
+      'M' => array(), // meta display mode
+    ),
+    'properties' => array(),
+    'icon' => array(
+      'style' => true,
+      'file' => '',
+      'width' => -1,
+      'height' => -1
+      )
+  );
+  protected $css2;
 
   public function __construct($prefixeTable, $filelocation)
   {
     parent::__construct($prefixeTable, $filelocation);
+    $this->css2 = new GPCCss(dirname($this->getFileLocation()).'/'.$this->getPluginNameFiles()."2.css");
     $this->loadConfig();
-
     $this->initEvents();
     $this->load_lang();
-
-    $this->pictureGeolocated=false;
-    $this->coords['lat']=0;
-    $this->coords['lng']=0;
-
-    $this->loadMaps();
   }
 
   public function __destruct()
   {
-    unset($section_page);
+    unset($maps);
+    unset($picture);
     parent::__destruct();
   }
@@ -61,7 +84,8 @@
     parent::initEvents();
 
-    //add_event_handler('loc_end_page_header', array(&$this, 'loadJS'));
-    add_event_handler('amd_jpegMD_loaded', array(&$this, 'prepareMap'));
-    add_event_handler('loc_begin_picture', array(&$this, 'applyMap'), 55);
+    add_event_handler('loc_begin_index', array(&$this, 'displayCategoryPageMap'));
+    add_event_handler('loc_begin_picture', array(&$this, 'displayPicturePageMap'), 55);
+    add_event_handler('amd_jpegMD_loaded', array(&$this, 'preparePictureMaps'));
+    add_event_handler('loc_end_page_header', array(&$this->css2, 'applyCSS'));
   }
 
@@ -72,113 +96,290 @@
   ------------------------------------------------------------------------- */
 
-
-
   /**
-   * build the maps
+   * this function display the map on the category page
    */
-  public function prepareMap($jpegMD)
-  {
-    global $template;
-
-    if(is_null($jpegMD->getTag('magic.GPS.LatitudeNum')) or
-       is_null($jpegMD->getTag('magic.GPS.LongitudeNum'))) return(false);
-
-    $this->coords['lat']=$jpegMD->getTag('magic.GPS.LatitudeNum')->getValue();
-    $this->coords['lng']=$jpegMD->getTag('magic.GPS.LongitudeNum')->getValue();
-
-    $this->pictureGeolocated=true;
-
-    $mapsProperties='';
-    foreach($this->maps as $val)
-    {
-      $this->content.="<div id='iGMaps".$val['id']."' style='width:".$val['width'].";height:".$val['height'].";".$val['style']."'></div>";
-
-      if($mapsProperties!='') $mapsProperties.=',';
-      $mapsProperties.="
-      {
-        id:'iGMaps".$val['id']."',
-        zoomLevel:".$val['zoomLevel'].",
-        displayMarker:".(($val['displayMarker']=='Y')?'true':'false').",
-        mapTypeId:'".$val['mode']."',
+  public function displayCategoryPageMap()
+  {
+    global $page, $prefixeTable, $template, $user, $conf;
+
+    if($page['section']=='categories')
+    {
+      if(isset($page['category']))
+      {
+        $this->category['id']=$page['category']['id'];
+        $this->buildMapList($page['category']['id'], 'C');
+        $sqlCatRestrict="AND FIND_IN_SET(".$page['category']['id'].", pct.uppercats)!=0";
       }
-      ";
-    }
-    $this->content="<div id='iGMapContent' style='text-align:center;'>".$this->content."</div>";
-
-    $template->append('head_elements',
+      else
+      {
+        $this->category['id']=0;
+        $this->buildMapList(0, 'C');
+        $sqlCatRestrict="";
+      }
+
+      if(count($this->maps)>0)
+      {
+        $scripts=array();
+
+        // check if there is picture with gps tag in the selected category
+        $sql="SELECT paut.tagId, MAX(CAST(pait.value AS DECIMAL(20,17))) AS maxValue, MIN(CAST(pait.value AS DECIMAL(20,17))) AS minValue
+              FROM (((".USER_CACHE_CATEGORIES_TABLE." pucc
+                LEFT JOIN ".CATEGORIES_TABLE." pct ON pucc.cat_id = pct.id)
+                LEFT JOIN ".IMAGE_CATEGORY_TABLE." pic ON pic.category_id = pucc.cat_id)
+                LEFT JOIN ".$prefixeTable."amd_images_tags pait ON pait.imageId = pic.image_id)
+                LEFT JOIN ".$prefixeTable."amd_used_tags paut ON pait.numId = paut.numId
+              WHERE pucc.user_id = '".$user['id']."'
+               AND (paut.tagId = 'magic.GPS.LatitudeNum' OR paut.tagId = 'magic.GPS.LongitudeNum')
+               AND pic.image_id IS NOT NULL
+               $sqlCatRestrict
+               GROUP BY paut.tagId";
+
+        $result=pwg_query($sql);
+        if($result)
+        {
+          $nb=0;
+          while($row=pwg_db_fetch_assoc($result))
+          {
+            switch($row['tagId'])
+            {
+              case 'magic.GPS.LatitudeNum':
+                $this->category['bounds']['N']=$row['maxValue'];
+                $this->category['bounds']['S']=$row['minValue'];
+                break;
+              case 'magic.GPS.LongitudeNum':
+                $this->category['bounds']['E']=$row['maxValue'];
+                $this->category['bounds']['W']=$row['minValue'];
+                break;
+            }
+            $nb++;
+          }
+
+          if($nb>0)
+          {
+            /*
+             * prepare js script for each map
+             */
+
+            foreach($this->maps as $keyMap => $map)
+            {
+              $scripts[]="
+              {
+                id:'iGMapsIcon',
+                zoomLevel:".$map['zoomLevel'].",
+                marker:true,
+                mapType:'".$map['mapType']."',
+                mapTypeControl:'".$map['mapTypeControl']."',
+                navigationControl:'".$map['navigationControl']."',
+                scaleControl:'".$map['scaleControl']."',
+                kmlFileUrl:'".$map['kmlFileUrl']."',
+                displayType:'".$map['displayType']."',
+                sizeMode:'".$map['sizeMode']."',
+                title:'".addslashes( ($map['title']=='')?l10n('gmaps_geolocation'):$map['title']  )."',
+                markers:[],
+                fitToBounds:true
+              }";
+
+              preg_match('/^i(\d+)x(\d+).*/i', basename($map['icon']), $result);
+              $this->category['icon']['iconStyle']=$map['iconStyle'];
+              $this->category['icon']['file']=$map['icon'];
+              $this->category['icon']['width']=isset($result[1])?$result[1]:-1;
+              $this->category['icon']['height']=isset($result[2])?$result[2]:-1;
+            }
+
+
+            $template->assign('maps', $this->maps);
+            $template->set_filename('gmapsCatMap',
+                        dirname($this->getFileLocation()).'/templates/gmaps_category.tpl');
+            $template->append('footer_elements', $template->parse('gmapsCatMap', true), false);
+
+            if(is_array($this->category['icon']))
+            {
+              $template->assign('mapIcon', $this->category['icon']);
+              $template->set_filename('gmapsIconButton',
+                          dirname($this->getFileLocation()).'/templates/gmaps_category_iconbutton.tpl');
+              $template->concat('PLUGIN_INDEX_ACTIONS', $template->parse('gmapsIconButton', true), false);
+              $template->assign('mapIcon');
+            }
+
+
+            $template->append('head_elements',
+  "<script type=\"text/javascript\">
+  gmaps =
+    {
+      lang:{
+        boundmap:'".l10n('gmaps_i_boundmap')."',
+        boundkml:'".l10n('gmaps_i_boundkml')."'
+      },
+      requestId:'',
+      categoryId:".$this->category['id'].",
+      bounds:
+        {
+          north:".$this->category['bounds']['N'].",
+          south:".$this->category['bounds']['S'].",
+          east:".$this->category['bounds']['E'].",
+          west:".$this->category['bounds']['W']."
+        },
+      maps:
+      [".implode(',', $scripts)."],
+    }
+  </script>", false);
+
+          }
+        }
+      }
+    }
+  }
+
+
+
+  /**
+   * this function display the map on the picture page
+   *
+   * the 'amd_jpegMD_loaded' event is triggered before the 'loc_begin_picture'
+   * event so, when this function is called the $this->picture var was already
+   * initialized
+   */
+  public function displayPicturePageMap()
+  {
+    global $page, $template;
+
+    if($this->picture['geolocated']==false) return(false);
+
+    if(count($this->picture['content']['MP'])>0)
+    {
+      // there is maps in meta display mode
+      $template->set_filename('gmapsMeta',
+                  dirname($this->getFileLocation()).'/templates/gmaps_picture_meta.tpl');
+      $template->assign('maps', $this->picture['content']['MP']);
+
+      $metadata=array
+        (
+          'TITLE' => l10n('gmaps_geolocation'),
+          'lines' =>
+            array(
+              /* <!--rawContent-->  is a trick to display raw data in tabs
+               * for the gally template
+               *
+               * on the default template, the displayed content is done
+               * normally
+               */
+              '<!--rawContent-->' => $template->parse('gmapsMeta', true)
+            )
+        );
+      $template->append('metadata', $metadata, false);
+    }
+
+    if(count($this->picture['content']['IP'])>0)
+    {
+      // there is maps in icon display mode
+      $template->assign('map', $this->picture['content']['IP'][0]);
+      $template->assign('mapIcon', $this->picture['icon']);
+
+      $template->set_filename('gmapsIconMap',
+                  dirname($this->getFileLocation()).'/templates/gmaps_picture_icon.tpl');
+      $template->append('footer_elements', $template->parse('gmapsIconMap', true), false);
+
+      $template->set_filename('gmapsIconButton',
+                  dirname($this->getFileLocation()).'/templates/gmaps_picture_iconbutton.tpl');
+      $template->concat('PLUGIN_PICTURE_ACTIONS',  $template->parse('gmapsIconButton', true), false);
+    }
+
+    if(count($this->picture['properties'])>0)
+    {
+      $template->append('head_elements',
 "<script type=\"text/javascript\">
   gmaps =
     {
+      lang:{
+        centermap:'".l10n('gmaps_i_centermap')."',
+        boundkml:'".l10n('gmaps_i_boundkml')."'
+      },
       coords:
       {
-        latitude:'".$this->coords['lat']."',
-        longitude:'".$this->coords['lng']."',
+        latitude:'".$this->picture['coords']['lat']."',
+        longitude:'".$this->picture['coords']['lng']."',
       },
       maps:
-      [$mapsProperties],
-    }
-</script>");
-
-
-    if(!isset($template->known_scripts)) $template->known_scripts=Array();
-
-    if(!array_key_exists('jquery', $template->known_scripts))
-    {
-      $template->known_scripts['jquery']='themes/default/js/jquery.packed.js';
-      $template->block_html_head(null, '<script type="text/javascript" src="themes/default/js/jquery.packed.js"></script>', $template->smarty, $false);
-    }
-
-    $template->known_scripts['maps.google.com/api']='http://maps.google.com/maps/api/js?sensor=false';
-    $template->block_html_head(null, '<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>', $template->smarty, $false);
-
-    $template->known_scripts['gmaps.gmaps']='plugins/'.basename(dirname(__FILE__)).'/js/gmaps.js';
-    $template->block_html_head(null, '<script type="text/javascript" src="plugins/'.basename(dirname(__FILE__)).'/js/gmaps.js"></script>', $template->smarty, $false);
-
-
-    //$template->append('head_elements', '<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>');
-    //$template->append('head_elements', '<script type="text/javascript" src="plugins/'.basename(dirname(__FILE__)).'/js/gmaps.js"></script>');
-  }
+      [".implode(',', $this->picture['properties'])."],
+    }
+</script>", false);
+    }
+  }
+
+
 
 
   /**
-   * add the maps container to the page
+   * prepare the maps for the picture page
+   *
+   * this function is called when the plugin AdvancedMetadata has finished to
+   * read the metadata ; if picture is not geolocated, there is no map to display
+   *
+   * @param JpegMetadata $jpegMD : a JpegMetadata object
    */
-  public function applyMap()
-  {
-    global $template;
-
-    if(!$this->pictureGeolocated) return(false);
-
-    $metadata=$template->get_template_vars('metadata');
-
-    $metadata[]=array
-      (
-        'TITLE' => l10n('gmaps_geolocation'),
-        'lines' =>
-          array(
-            '<!--rawContent-->' => $this->content
-          )
+  public function preparePictureMaps($jpegMD)
+  {
+    global $template, $page;
+
+    if(is_null($jpegMD->getTag('magic.GPS.LatitudeNum')) or
+       is_null($jpegMD->getTag('magic.GPS.LongitudeNum')) or
+       $page['section']!='categories') return(false);
+
+
+    $this->picture['geolocated']=true;
+    $this->picture['coords']['lat']=$jpegMD->getTag('magic.GPS.LatitudeNum')->getValue();
+    $this->picture['coords']['lng']=$jpegMD->getTag('magic.GPS.LongitudeNum')->getValue();
+
+
+    if(isset($page['category']))
+    {
+      $this->buildMapList($page['category']['id'], 'P');
+    }
+    else
+    {
+      $this->buildMapList(0, 'P');
+    }
+
+
+    foreach($this->maps as $map)
+    {
+      if($map['displayType']=='IP')
+      {
+        preg_match('/^i(\d+)x(\d+).*/i', basename($map['icon']), $result);
+        $this->picture['icon']=array(
+          'iconStyle' => $map['iconStyle'],
+          'file' => $map['icon'],
+          'width' => isset($result[1])?$result[1]:-1,
+          'height' => isset($result[2])?$result[2]:-1
+        );
+      }
+
+
+      $this->picture['content'][$map['displayType']][]=array(
+        'id' => $map['id'],
+        'width' => $map['width'],
+        'height' => $map['height'],
+        'style' => $map['style'],
+        'mode' => $map['displayType']
       );
-    $template->assign('metadata', $metadata);
-  }
-
-
-  /**
-   * loads the maps list
-   */
-  private function loadMaps()
-  {
-    $sql="SELECT id, width, height, zoomLevel, displayMarker, mode, style
-          FROM ".$this->tables['maps']."
-          ORDER BY id";
-    $result=pwg_query($sql);
-    if($result)
-    {
-      while($row=pwg_db_fetch_assoc($result))
-      {
-        $this->maps[]=$row;
-      }
-    }
-  }
+
+      $this->picture['properties'][]="
+      {
+        id:'iGMaps".(($map['displayType']=='IP')?'Icon':$map['id'])."',
+        zoomLevel:".$map['zoomLevel'].",
+        marker:true,
+        mapType:'".$map['mapType']."',
+        mapTypeControl:'".$map['mapTypeControl']."',
+        navigationControl:'".$map['navigationControl']."',
+        scaleControl:'".$map['scaleControl']."',
+        kmlFileUrl:'".$map['kmlFileUrl']."',
+        displayType:'".$map['displayType']."',
+        sizeMode:'".$map['sizeMode']."',
+        title:'".addslashes( ($map['title']=='')?l10n('gmaps_geolocation'):$map['title']  )."'
+      }";
+    }
+  }
+
+
 
 
Index: extensions/GMaps/gmaps_root.class.inc.php
===================================================================
--- extensions/GMaps/gmaps_root.class.inc.php	(revision 7054)
+++ extensions/GMaps/gmaps_root.class.inc.php	(revision 7125)
@@ -19,4 +19,54 @@
     protected $css;
 
+    /**
+     * check the available AMD release
+     */
+    static public function checkAMDRelease()
+    {
+      if(!defined('AMD_VERSION')) return(false);
+
+      $currentAMDRelease = explode(".", GPC_VERSION);
+
+      $neededAMDRelease=explode('.', GMAPS_AMD_NEEDED);
+      $major=$neededAMDRelease[0];
+      $minor=$neededAMDRelease[1];
+      $minor2=$neededAMDRelease[2];
+
+      if(($currentAMDRelease[0]>$major) ||
+         ($currentAMDRelease[0]==$major)&&($currentAMDRelease[1]>$minor) ||
+         ($currentAMDRelease[0]==$major)&&($currentAMDRelease[1]==$minor)&&($currentAMDRelease[2]>=$minor2))
+      {
+        return(true);
+      }
+      return(false);
+    }
+
+    /**
+     * check if AMD plugin is activated and mode
+     *
+     * @return String : 'none' if plugin is not installed
+     *                  'inactive' if plugin is not active
+     *                  'basic' if plugin active in basic mode
+     *                  'advanced' if plugin active in advanced mode
+     */
+    static public function checkAMDActivated()
+    {
+      if(!self::checkAMDRelease()) return('none');
+
+      $sql="SELECT state FROM ".PLUGINS_TABLE." WHERE id='AMetaData';";
+      $result=pwg_query($sql);
+      if($result)
+      {
+        $row=pwg_db_fetch_assoc($result);
+        if(!(isset($row['state']) and $row['state']='active')) return('inactive');
+
+        $amdConfig=array();
+        GPCCore::loadConfig('amd', $amdConfig);
+
+        return($amdConfig['amd_InterfaceMode']);
+      }
+    }
+
+
     public function __construct($prefixeTable, $filelocation)
     {
@@ -26,5 +76,5 @@
       $this->section_name=$this->getPluginNameFiles();
 
-      $this->setTablesList(array('maps', 'category_maps'));
+      $this->setTablesList(array('maps', 'category_maps', 'cache'));
       $this->css = new GPCCss(dirname($this->getFileLocation()).'/'.$this->getPluginNameFiles().".css");
     }
@@ -37,5 +87,4 @@
     public function initEvents()
     {
-      add_event_handler('blockmanager_register_blocks', array(&$this, 'register_blocks') );
     }
 
@@ -111,7 +160,117 @@
 
     /* ---------------------------------------------------------------------------
-      ajax functions
+
     --------------------------------------------------------------------------- */
 
+    /**
+     * update the given bound with the given coords
+     *
+     * @param &Array $bounds : the bounds (N,S,E,W)
+     * @param Array $coords  : coords (0=>lat, 1=>lng)
+     */
+    protected function updateBounds(&$bounds, $coords)
+    {
+      if($bounds['E']<$coords['lng']) $bounds['E']=$coords['lng'];
+      if($bounds['N']<$coords['lat']) $bounds['N']=$coords['lat'];
+      if($bounds['W']>$coords['lng']) $bounds['W']=$coords['lng'];
+      if($bounds['S']>$coords['lat']) $bounds['S']=$coords['lat'];
+    }
+
+    /**
+     * build the list of maps (initialize the $this->maps var)
+     *
+     * used by GMaps_ajax & GMaps_pip classes
+     *
+     * @param Array $categories : array of categories id (cat + parent list)
+     * @param String $page : 'P' for picture page, 'C' for category page
+     */
+    protected function buildMapList($category, $page)
+    {
+      global $template ;
+
+      if($page=='C')
+      {
+        $where=" displayType='IC' ";
+      }
+      else
+      {
+        $where=" (displayType='IP' or displayType='MP') ";
+      }
+
+      /*
+       * sql request select all possible association, sorted from the highest to
+       * the lowest priority
+       */
+      $sql="SELECT DISTINCT pgcm.id, pgcm.categoryId,
+              pgcm.imgSort, pgcm.applySubCat, pgcm.kmlFileUrl,
+              pgcm.icon, pgcm.title,
+              pgmm.displayType, pgmm.sizeMode,
+              pgmm.width, pgmm.height, pgmm.zoomLevel,
+              pgmm.mapType, pgmm.mapTypeControl, pgmm.scaleControl,
+              pgmm.navigationControl, pgmm.style,
+              IF(pgcm.categoryId=0, 0, pct.global_rank) AS priorityRank
+            FROM (".$this->tables['category_maps']." pgcm
+              LEFT JOIN ".$this->tables['maps']." pgmm ON pgcm.mapId = pgmm.id)
+              LEFT JOIN ".CATEGORIES_TABLE." pct ON (FIND_IN_SET(pgcm.categoryId, pct.uppercats)!=0 OR pgcm.categoryId=0)
+            WHERE $where ";
+      if($category!=0)
+      {
+        $sql.=" AND pct.id = '$category' ";
+      }
+      else
+      {
+        $sql.=" AND pgcm.categoryId = 0 ";
+      }
+      $sql.=" AND pgcm.applySubCat='y'
+            ORDER BY priorityRank DESC, pgmm.displayType ASC, pgcm.categoryId ASC, pgcm.imgSort ASC;";
+      $result=pwg_query($sql);
+
+      if($result)
+      {
+        // for each found row, choose the highest only
+        $pcat='';
+        $displayType=array(
+         'IC' => true,
+         'IP' => true,
+         'MP' => true,
+        );
+        while($row=pwg_db_fetch_assoc($result))
+        {
+          if($row['displayType']!='MP')
+          {
+            $themeConf=$template->get_template_vars('themeconf');
+            $fileName=preg_replace('/^([i|c]\d+x\d+)(?:_\d+){0,1}(\..*)/i', '$1$2', $row['icon']);
+
+            if(file_exists(PHPWG_ROOT_PATH.$themeConf['icon_dir'].'/gmaps/'.$fileName))
+            {
+              $row['icon']=$themeConf['icon_dir'].'/gmaps/'.$fileName;
+              $row['iconStyle']=false;
+            }
+            else
+            {
+              $row['icon']='plugins/GMaps/img/'.$row['icon'];
+              $row['iconStyle']=true;
+            }
+          }
+
+          if($displayType[$row['displayType']])
+          {
+            if($row['displayType']=='MP')
+            {
+              if($displayType['MP'] and ($row['categoryId']==$pcat or $pcat=='')) $this->maps[]=$row;
+              if($displayType['MP'] and $row['categoryId']!=$pcat and $pcat!='') $displayType['MP']=false;
+              $pcat=$row['categoryId'];
+            }
+            else
+            {
+              $this->maps[]=$row;
+              $displayType[$row['displayType']]=false;
+            }
+          }
+        }
+      }
+    }
+
+
 
   } //class
Index: extensions/GMaps/gmaps_version.inc.php
===================================================================
--- extensions/GMaps/gmaps_version.inc.php	(revision 7054)
+++ extensions/GMaps/gmaps_version.inc.php	(revision 7125)
@@ -18,3 +18,4 @@
   define('GMAPS_VERSION2', '00.02.00');
   define('GMAPS_GPC_NEEDED', '3.2.0');
+  define('GMAPS_AMD_NEEDED', '0.5.2'); //advanced metadata plugin is needed
 ?>
